#include <Controls\Dialog.mqh>
#include <Controls\Button.mqh>
//+------------------------------------------------------------------+
#define INDENT_LEFT                         (11)      // indent from left (with allowance for border width)
#define INDENT_TOP                          (11)      // indent from top (with allowance for border width)
//--- for button
#define BUTTON_WIDTH                        (100)     // size by X coordinate
#define BUTTON_HEIGHT                       (40)      // size by Y coordinate
//+------------------------------------------------------------------+
class CHWDialog : public CAppDialog
{
private:
   CButton           m_button;                       // the button object
public:
                     CHWDialog(void)   {}
                    ~CHWDialog(void)   {}
   //--- create
   virtual bool      Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2);
   //--- chart event handler
   virtual bool      OnEvent(const int id,const long &lparam,const double &dparam,const string &sparam);
protected:
   //--- create dependent controls
   bool              CreateButton(void);
   void              OnClickButton(void);
   void              OnClickButtonMinMax(void);
   void              OnClickButtonClose(void);
};
//+------------------------------------------------------------------+
//| Event Handling                                                   |
//+------------------------------------------------------------------+
EVENT_MAP_BEGIN(CHWDialog)
   ON_EVENT(ON_CLICK,m_button,OnClickButton)
EVENT_MAP_END(CAppDialog)
//+------------------------------------------------------------------+
//| Create                                                           |
//+------------------------------------------------------------------+
bool CHWDialog::Create(const long chart,const string name,const int subwin,const int x1,const int y1,const int x2,const int y2)
  {
   if(!CAppDialog::Create(chart,name,subwin,x1,y1,x2,y2)) return(false);
//--- create dependent controls
   if(!CreateButton()) return(false);
//--- succeed
   return(true);
}
//+------------------------------------------------------------------+
//| Create the "Button" button                                       |
//+------------------------------------------------------------------+
bool CHWDialog::CreateButton(void)
{
//--- coordinates
   int x1=INDENT_LEFT;
   int y1=INDENT_TOP;
   int x2=x1+BUTTON_WIDTH;
   int y2=y1+BUTTON_HEIGHT;
//--- create
   if(!m_button.Create(m_chart_id,m_name+"hw",m_subwin,x1,y1,x2,y2)) return(false);
   if(!m_button.Text("Hello World!")) return(false);
   if(!Add(m_button))  return(false);
//--- succeed
   return(true);
}
//+------------------------------------------------------------------+
//| Event handler                                                    |
//+------------------------------------------------------------------+
CHWDialog::OnClickButton(void)
{
   Alert("Press button");
}
//+------------------------------------------------------------------+
//| Event handler                                                    |
//+------------------------------------------------------------------+
CHWDialog::OnClickButtonMinMax(void)
{
   CAppDialog::OnClickButtonMinMax();
   if(m_minimized) Alert("Minimize window");
      else         Alert("Maximize window");
}
//+------------------------------------------------------------------+
//| Event handler                                                    |
//+------------------------------------------------------------------+
CHWDialog::OnClickButtonClose(void)
{
   Alert("Close program");
   CAppDialog::OnClickButtonClose();
}
